//ImageMenuItem Class for C#
//Version 1.1
//Copyright 2003-2005 DOBON! All rights reserved.
//쐬ҁAҁFǂڂI http://dobon.net
//i͍̕폜ȂłBj

using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;
using System.Drawing.Imaging;
using System.Windows.Forms;
using System.Drawing.Drawing2D;

namespace Dobon.Samples.Controls
{
	/// <summary>
	/// j[ڂɃACRi摜j\邽߂̃NX
	/// </summary>
	public class ImageMenuItem : MenuItem
	{
		//萔-----------------------------------------
		//\摜̃TCY
		private const int imageHeight = 16;
		private const int imageWidth = 16;
		//̗]i̗]ɂȂj
		private const int topMargin = 1;
		//̗]
		private const int leftMargin = 2;
		//摜ƃeLXg̊Ԋu
		private const int intervalImageAndText = 4;
		//E̗]
		private const int rightMargin = 20;
		//j[̃eLXg̕\ʒu
		private const int textLeft =
			leftMargin + imageWidth + intervalImageAndText;
		//eLXgȊO̕̕
		private const int widthExceptText =
			imageWidth + leftMargin + intervalImageAndText + rightMargin;
		//Office97 StylêƂ̑IF̕`Jnʒu(XW)
		private const int selectedColorLeft =
			leftMargin * 2 + imageWidth;

		//vpeB-----------------------------------
		private Image _image;
		/// <summary>
		/// \摜
		/// </summary>
		public Image Image
		{
			get
			{
				return _image;
			}
			set
			{
				if (_disabledImage != null)
				{
					_disabledImage.Dispose();
					_disabledImage = null;
				}
				_image = value;
			}
		}

		private Image _disabledImage;
		private Image DisabledImage
		{
			get
			{
				if (_disabledImage == null)
				{
					_disabledImage = CreateDisabledImage(_image);
				}
				return _disabledImage;
			}
		}

		public enum MenuStyle
		{
			Normal,
			Office97,
		};
		private MenuStyle _menuStyle;
		/// <summary>
		/// j[̃X^C
		/// </summary>
		public MenuStyle Style
		{
			get
			{
				return _menuStyle;
			}
			set
			{
				_menuStyle = value;
			}
		}

		//RXgN^-------------------------------
		public ImageMenuItem(string text) : base(text)
		{
			this.OwnerDraw = true;
			this._menuStyle = MenuStyle.Office97;
		}

		//\bh-------------------------------------
		protected override void Dispose(bool disposing)
		{
			if (_disabledImage != null)
			{
				_disabledImage.Dispose();
				_disabledImage = null;
			}
			base.Dispose(disposing);
		}

		/// <summary>
		/// OnMeasureItem̃I[o[Ch
		/// j[ACȇ傫vZ
		/// "e.ItemHeight"ɕ"e.ItemWidth"ɓ
		/// </summary>
		/// <param name="e"></param>
		protected override void OnMeasureItem(MeasureItemEventArgs e)
		{
			//{NXOnMeasureItem
			base.OnMeasureItem(e);

			//j[ɕ\镶擾
			string menuText;
			menuText = Text;
			//V[gJbg\Ƃ́A̕ǉ
			if (ShowShortcut == true &&
				Shortcut != Shortcut.None)
			{
				menuText +=
					TypeDescriptor.GetConverter(typeof(Keys)).
					ConvertToString((Keys) Shortcut);
			}

			StringFormat sf = new StringFormat();
			//zbgL[vtBbNX̕\(&_ɂ)
			sf.HotkeyPrefix = HotkeyPrefix.Show;

			//肷
			e.ItemWidth = (int)
				e.Graphics.MeasureString(menuText,
				SystemInformation.MenuFont,
				int.MaxValue,
				sf).Width + widthExceptText;
			//\[XJ
			sf.Dispose();

			//肷
			e.ItemHeight =
				Math.Max(SystemInformation.MenuFont.Height, imageHeight)
				+ topMargin * 2;
		}

		/// <summary>
		/// OnDrawItem̃I[o[Ch
		/// j[ڂ`悷
		/// </summary>
		/// <param name="e"></param>
		protected override void OnDrawItem(DrawItemEventArgs e)
		{
			Color textColor;

			//{NXOnDrawItem
			base.OnDrawItem(e);

			if ((e.State & DrawItemState.Disabled) != 0)
			{
				//Ԃ̎
				//wihԂ
				e.Graphics.FillRectangle(SystemBrushes.Menu, e.Bounds);
				//̕`ɎgpFw
				textColor = SystemColors.ControlDark;
			}
			else if ((e.State & DrawItemState.Selected) == 0)
			{
				//IĂȂ
				//wihԂ
				e.Graphics.FillRectangle(SystemBrushes.Menu, e.Bounds);
				//̕`ɎgpFw
				textColor = SystemColors.MenuText;
			}
			else
			{
				//IĂ鎞
				//wihԂ
				if (_menuStyle == MenuStyle.Normal || 
					(_image == null && !Checked))
					e.Graphics.FillRectangle(SystemBrushes.Highlight,
						e.Bounds);
				else
					e.Graphics.FillRectangle(SystemBrushes.Highlight,
						selectedColorLeft, e.Bounds.Top,
						e.Bounds.Width - selectedColorLeft, e.Bounds.Height);
				//̕`ɎgpuV̍쐬
				textColor = SystemColors.HighlightText;
			}

			//摜̕`
			//`ʒǔ
			Point imagePoint = new Point();
			imagePoint.X = e.Bounds.Left + leftMargin;
			imagePoint.Y =
				e.Bounds.Top + (e.Bounds.Height - imageHeight) / 2;
			//`
			if ((e.State & DrawItemState.Checked) != 0)
			{
				//`FbNtĂƂ̓`FbN`
				DrawMenuCheckmark(e,
					RadioCheck,
					textColor,
					imagePoint.X,
					imagePoint.Y);
			}
			else
			{
				//摜̕`
				if (_image != null)
				{
					DrawMenuImage(e,
						_image,
						imagePoint.X,
						imagePoint.Y);
				}
			}

			//̕`̏
			StringFormat sf = new StringFormat();
			//zbgL[vtBbNX̕\(&A_[Cɂ)
			sf.HotkeyPrefix = HotkeyPrefix.Show;

			//Text̕\ʒu肷
			PointF textPosition = new PointF();
			textPosition.X = e.Bounds.Left + textLeft;
			textPosition.Y = e.Bounds.Top +
				(e.Bounds.Height - SystemInformation.MenuFont.Height) / 2;

			//Text̕`
			Brush textBrush;
			textBrush = new SolidBrush(textColor);
			DrawMenuText(e,
				Text,
				textBrush,
				textPosition,
				sf);

			//Shortcut`
			if (ShowShortcut == true &
				Shortcut != Shortcut.None)
			{
				//Shortcut̕擾
				string  shortcutText=
					TypeDescriptor.GetConverter(typeof(Keys)).
					ConvertToString((Keys) Shortcut);
				//Shortcut̕擾
				int  shortcutWidth=
					(int)
					e.Graphics.MeasureString(shortcutText,
					SystemInformation.MenuFont,
					int.MaxValue,
					sf).Width;
				//Shortcut̕\ʒu肷
				PointF shortcutPosition = new PointF();
				shortcutPosition.X =
					e.Bounds.Right - shortcutWidth - rightMargin;
				shortcutPosition.Y = textPosition.Y;
				//Shortcut̕`
				DrawMenuText(e,
					shortcutText,
					textBrush,
					shortcutPosition,
					sf);
			}

			//\[XJ
			textBrush.Dispose();
			sf.Dispose();
		}

		/// <summary>
		/// ̕`
		/// </summary>
		/// <param name="e">`DrawItemEventArgs</param>
		/// <param name="text">`悷镶</param>
		/// <param name="textBrush">`ɎgpuV</param>
		/// <param name="point">`ʒu</param>
		/// <param name="sf"></param>
		private static void DrawMenuText(DrawItemEventArgs e, string text,
			Brush textBrush, PointF point, StringFormat sf)
		{

			if ((e.State & DrawItemState.Disabled) != 0)
			{
				//Ԃ̂Ƃ͉e`悷
				e.Graphics.DrawString(text,
					SystemInformation.MenuFont,
					SystemBrushes.ControlLightLight,
					point.X + 1, point.Y + 1,
					sf);
			}

			//̕`
			e.Graphics.DrawString(text,
				SystemInformation.MenuFont,
				textBrush,
				point,
				sf);
		}

		/// <summary>
		/// 摜̕`
		/// </summary>
		/// <param name="e">`DrawItemEventArgs</param>
		/// <param name="img">`悷摜</param>
		/// <param name="x">`悷ʒu</param>
		/// <param name="y">`悷ʒu</param>
		private void DrawMenuImage(DrawItemEventArgs e, Image img, int x, int y)
		{

			if ((e.State & DrawItemState.Disabled) == 0)
			{
				//LԂ̎
				if (_menuStyle == MenuStyle.Office97 && 
					(e.State & DrawItemState.Selected) != 0)
				{
					//g`
					DrawImageFrame(e, x, y, false);
				}
				e.Graphics.DrawImage(img,
					x,
					y,
					imageWidth,
					imageHeight);
			}
			else
			{
				//Ԃ̎
				e.Graphics.DrawImage(DisabledImage,
					x,
					y,
					imageWidth + 1,
					imageHeight + 1);
			}
		}

		/// <summary>
		/// Ԃ̉摜쐬
		/// </summary>
		/// <param name="img">ɂȂ摜</param>
		private static Image CreateDisabledImage(Image img)
		{
			if (img == null)
			{
				return null;
			}

			//Ԃ̉摜 ̉摜c1hbg傫Ȃ
			Bitmap dbmp = new Bitmap(img.Width + 1, img.Height + 1);
			//Ƃ̉摜
			Bitmap bmp = new Bitmap(img);

			//1hbgׂ
			for (int y = 0; y < bmp.Height; y++)
			{
				for (int x = 0; x < bmp.Width; x++)
				{
					//̐FA邢F𓧖ɂ
					if (bmp.GetPixel(x, y).A == 0xFF &&
						bmp.GetPixel(x, y).GetBrightness() < 1.0F)
					{
						dbmp.SetPixel(x, y, SystemColors.ControlDark);
						dbmp.SetPixel(x + 1, y + 1,
							SystemColors.ControlLightLight);
					}
				}
			}

			bmp.Dispose();
			return dbmp;
		}

		/// <summary>
		/// j[̃`FbN}[N̕`
		/// </summary>
		/// <param name="e">`DrawItemEventArgs</param>
		/// <param name="radio">Radio Button`悷邩</param>
		/// <param name="foreColor">OiF</param>
		/// <param name="x">`悷ʒu</param>
		/// <param name="y">`悷ʒu</param>
		private void DrawMenuCheckmark(DrawItemEventArgs e, bool radio,
			Color foreColor, int x, int y)
		{
			if (_menuStyle == MenuStyle.Normal)
			{
				//VBitmapIuWFNg̍쐬
				Bitmap bmp = new Bitmap(imageWidth, imageHeight);
				Graphics bmpg = Graphics.FromImage(bmp);

				//쐬BitmapIuWFNgɃ`FbN}[N`
				ControlPaint.DrawMenuGlyph(bmpg,
					0, 0, imageWidth, imageHeight,
					radio ? MenuGlyph.Bullet : MenuGlyph.Checkmark);

				if ((e.State & DrawItemState.Disabled) != 0)
				{
					//Ԃ̂Ƃ͉e`悷
					//ImageAttributesw肵ĕ`
					e.Graphics.DrawImage(bmp,
						new Rectangle(x + 1, y + 1, bmp.Width, bmp.Height),
						0, 0, bmp.Width, bmp.Height, GraphicsUnit.Pixel,
						CreateImageAttributes(SystemColors.ControlLightLight));
				}

				//ImageAttributesw肵ĕ`
				e.Graphics.DrawImage(bmp,
					new Rectangle(x, y, bmp.Width, bmp.Height),
					0, 0, bmp.Width, bmp.Height, GraphicsUnit.Pixel,
					CreateImageAttributes(foreColor));

				bmpg.Dispose();
				bmp.Dispose();
			}
			else
			{
				//Office97X^C
				//g`
				DrawImageFrame(e, x, y, true);

				//wih
				Brush backBrush;
				if ((e.State & DrawItemState.Selected) == 0 ||
					!Enabled)
				{
					backBrush = new HatchBrush(HatchStyle.Percent50, 
						SystemColors.Menu, SystemColors.ControlLightLight);
				}
				else
				{
					backBrush = new SolidBrush(SystemColors.Menu);
				}
				e.Graphics.FillRectangle(backBrush, x, y, imageWidth, imageHeight);
				backBrush.Dispose();

				if (_image == null)
				{
					//`FbN}[N̕`
					DrawOffice97Checkmark(e.Graphics, radio, x, y, !Enabled);
				}
				else
				{
					//摜̕`
					e.Graphics.DrawImage(_image,
						x,
						y,
						imageWidth,
						imageHeight);
				}
			}
		}

		/// <summary>
		/// w肵FŁA𓧖Fɒu
		/// </summary>
		/// <param name="foreColor">ƓւF</param>
		private static ImageAttributes CreateImageAttributes(Color foreColor)
		{
			//Fւ邽߂̏
			ColorMap [] cms=
				new ColorMap[] {new ColorMap(), new ColorMap()};
			//ւFw肷
			cms[0].OldColor = Color.Black;
			cms[0].NewColor = foreColor;
			cms[1].OldColor = Color.White;
			cms[1].NewColor = Color.Transparent;
			//ImageAttributesIuWFNg̍쐬
			ImageAttributes imageAttr = new ImageAttributes();
			imageAttr.SetRemapTable(cms);
			//lԂ
			return imageAttr;
		}

		/// <summary>
		/// Office97^CṽACR̘g`悷
		/// </summary>
		/// <param name="e">`DrawItemEventArgs</param>
		/// <param name="x">ACRXW</param>
		/// <param name="y">ACRYW</param>
		/// <param name="down">E񂾘g`</param>
		private static void DrawImageFrame(DrawItemEventArgs e, int x, int y, bool down)
		{
			//y̌
			Pen p1, p2;
			if (!down)
			{
				p1 = SystemPens.ControlLightLight;
				p2 = SystemPens.ControlDark;
			}
			else
			{
				p1 = SystemPens.ControlDark;
				p2 = SystemPens.ControlLightLight;
			}

			e.Graphics.DrawLines(p1,
				new Point[] {new Point(x - 1, y + imageHeight - 1),
								new Point(x - 1, y - 1),
								new Point(x + imageWidth - 1, y - 1)});
			e.Graphics.DrawLines(p2,
				new Point[] {new Point(x - 1, y + imageHeight),
								new Point(x + imageWidth, y + imageHeight),
								new Point(x + imageWidth, y - 1)});
		}

		/// <summary>
		/// Office97^Cṽ`FbN}[N`悷
		/// </summary>
		/// <param name="g">`Graphics</param>
		/// <param name="radio">RADIO}[N</param>
		/// <param name="x">ACRXW</param>
		/// <param name="y">ACRYW</param>
		/// <param name="disabled">Ԃ</param>
		private static void DrawOffice97Checkmark(Graphics g, bool radio,
			int x, int y, bool disabled)
		{
			g.SetClip(new Rectangle(x, y, imageWidth, imageHeight));
			g.TranslateTransform(x + (imageWidth - 16), y + (imageHeight - 16));

			if (!radio)
			{
				Color halfDark = Color.FromArgb(
					(SystemColors.ControlLightLight.R + SystemColors.ControlDark.R) / 2,
					(SystemColors.ControlLightLight.G + SystemColors.ControlDark.G) / 2,
					(SystemColors.ControlLightLight.B + SystemColors.ControlDark.B) / 2);
				Pen halfDarkPen = new Pen(halfDark);

				Point[] darkLine = new Point[] {new Point(4, 6), new Point(6, 8), new Point(10, 4)};
				Point[] light2Line = new Point[] {new Point(3, 7), new Point(3, 8), new Point(6, 11), new Point(11, 6), new Point(11, 5)};
				Point[] foreLine1 = new Point[] {new Point(4, 7), new Point(6, 9), new Point(10, 5)};
				Point[] foreLine2 = new Point[] {new Point(4, 8), new Point(6, 10), new Point(10, 6)};

				if (!disabled)
				{
					g.DrawLines(halfDarkPen, darkLine);
					g.DrawLines(SystemPens.MenuText, foreLine1);
					g.DrawLines(SystemPens.MenuText, foreLine2);
					g.DrawLines(SystemPens.ControlLightLight, light2Line);
				}
				else
				{
					g.DrawLines(SystemPens.ControlDark, foreLine1);
					g.DrawLines(SystemPens.ControlDark, foreLine2);
					g.DrawLines(SystemPens.ControlLightLight, light2Line);
				}

				halfDarkPen.Dispose();
			}
			else
			{
				//RADIO}[N̎
				Color foreColor;
				if (!disabled)
				{
					foreColor = SystemColors.MenuText;
				}
				else
				{
					foreColor = SystemColors.ControlDark;
				}

				Pen forePen = new Pen(foreColor);
				SolidBrush foreBrush = new SolidBrush(foreColor);

				g.DrawLine(forePen, new Point(6, 5), new Point(9, 5));
				g.FillRectangle(foreBrush, 5, 6, 6, 4);
				g.DrawLine(forePen, new Point(6, 10), new Point(9, 10));

				forePen.Dispose();
				foreBrush.Dispose();
			}

			g.ResetTransform();
			g.ResetClip();
		}
	}
}
